function getPrintName(%id)
{
	%texture = getPrintTexture(%id);
	%package = getField(strreplace(%tex,"/","\t"),1);
	%category = getField(strReplace(%package,"_","\t"),1);
	%name = fileBase(%texture);
	%return = %category @ "/" @ %name;
	return %return;
}

function ServerSave(%name,%ownership,%events)
{
	if(%name $= "")
	{
		error("\c2No name specified in serverSave!");
		echo("\c2usage: serverSave(string savename, bool ownership, bool events");
	}
	if(!isObject(MissionCleanup))
	{
		error("Nothing to save!");
	}
	if(%ownership $= "")		//on by default
		%ownership = 1;
	if(%events $= "")
		%events = 1;
	%file = new FileObject();
	%location = "saves/" @ MissionInfo.saveName @ "/" @ %name @ ".bls";
	%file.openForWrite(%location);
	%file.writeLine("This is a Blockland save file.  You probably shouldn't modify it cause you'll screw it up.");
	%file.writeLine("1");
	%file.writeLine("");
	for(%x=0;%x<64;%x++)
		%file.writeLine(getColorIDTable(%x));
	%brickcount = 0;
	for(%x=0;%x<mainBrickGroup.getCount();%x++)
		%brickCount+=mainBrickGroup.getObject(%x).getCount();
	%file.writeLine("Linecount " @ %brickCount);
	%b=0;
	for(%y=0;%y<mainBrickGroup.getCount();%y++)	//Get the baseplates first to save ownership
	{
		%bg = mainBrickGroup.getObject(%y);
		for(%z=0;%z<%bg.getCount();%z++)
		{
			if(%bg.getObject(%z).isBasePlate())
			{
				%baseplate[%b] = %bg.getObject(%z);
				%b++;
			}
		}
	}
	for(%x=0;%x<%b;%x++) //Save the baseplates first so ownership doesn't mess up
	{
		if(!%baseplate[%x].isPlanted)
			continue;
		%v1 = %baseplate[%x].getDatablock().uiName @ "\"";
		%v2 = %baseplate[%x].position;
		%v3 = %baseplate[%x].angleID;
		%v4 = %baseplate[%x].isBasePlate;
		%v5 = %baseplate[%x].colorID;
		if(%baseplate[%x].getDatablock().hasPrint)
			%v6 = getPrintName(%baseplate[%x].printID);
		else
			%v6 = "";
		%v7 = %baseplate[%x].colorFxID;
		%v8 = %baseplate[%x].shapeFxID;
		%v9 = %baseplate[%x].isRayCasting();
		%v10 = %baseplate[%x].isColliding();
		%v11 = %baseplate[%x].isRayCasting();
		%file.writeLine(%v1 SPC %v2 SPC %v3 SPC %v4 SPC %v5 SPC %v6 SPC %v7 SPC %v8 SPC %v9 SPC %v10 SPC %v11);
		if(%ownership)
			%file.writeLine("+-OWNER " @ %baseplate[%x].getGroup().bl_id);
		if(%events)
		{
			if(%baseplate[%x].getName() !$= "")
				%file.writeLine("+-NTOBJECTNAME " @ %baseplate[%x].getName());
			for(%y=0;%y<%baseplate[%x].numEvents;%y++)
			{
				%e1 = %baseplate[%x].eventEnabled[%y];
				%e2 = %baseplate[%x].eventInput[%y];
				%e3 = %baseplate[%x].eventDelay[%y];
				%e4 = %baseplate[%x].eventTarget[%y];
				%et = %baseplate[%x].eventNT[%y];
				%e5 = %baseplate[%x].eventOutput[%y];
				for(%ev=1;%ev<=4;%ev++)
				{
					%e[%ev+5] = %baseplate[%x].eventOutPutParameter[%y,%ev];
					if(%e[%ev+5] !$= "")
					{
						%iIDx = %baseplate[%x].eventInputIdx[%y];
						%tIDx = %baseplate[%x].eventTargetIdx[%y];
						%oIDx = %baseplate[%x].eventOutputIdx[%y];
						if(%tIDx == -1)
							%targetClass = "fxDTSBrick";
						else
							%targetClass = getWord(getField($InputEvent_TargetList["fxDTSBrick",%iIDx],%tIDx),1);
						if(getWord(getField($OutputEvent_parameterList[%targetClass,%oIDx],%ev-1),0) $= "dataBlock")
						%e[%ev+5] = %e[%ev+5].getName();
					}	
				}
				%file.writeLine("+-EVENT" TAB %y TAB %e1 TAB %e2 TAB %e3 TAB %e4 TAB %et TAB %e5 TAB %e6 TAB %e7 TAB %e8 TAB %e9);
			}
		}
		if(isObject(%baseplate[%x].emitter))
			%file.writeLine("+-EMITTER" SPC %baseplate[%x].emitter.emitter.uiName @ "\" " @ %baseplate[%x].emitterDirection);
		if(isObject(%baseplate[%x].light))
			%file.writeLine("+-LIGHT" SPC %baseplate[%x].light.getDatablock().uiName @ "\" ");
		if(isObject(%baseplate[%x].item))
			%file.writeLine("+-ITEM" SPC %baseplate[%x].item.getDatablock().uiName @ "\" " @ %baseplate[%x].itemPosition SPC %baseplate[%x].itemDirection SPC %baseplate[%x].itemRespawnTime);
		if(isObject(%baseplate[%x].AudioEmitter))
			%file.writeLine("+-AUDIOEMITTER" SPC %baseplate[%x].audioemitter.profile.uiName @ "\" ");
		if(isObject(%baseplate[%x].vehicleDataBlock))
			%file.writeLine("+-VEHICLE" SPC %baseplate[%x].vehicledatablock.uiName @ "\" " @ %baseplate[%x].reColorVehicle);
		%saved[%baseplate[%x]] = 1;
	}
	for(%x=0;%x<%b;%x++) //Now start getting the bricks attached to the baseplate
	{			//Gonna make stack lists like duplicator does...
		%stackBrick[%baseplate[%x]] = 1;
		%stackList[0] = %baseplate[%x];
		%stackHead = 1;
		for(%stackTail = 0; %stackTail != %stackHead; %stackTail++)
		{
			%currBrick = %stackList[%stackTail];
			if(!%saved[%currBrick])
			{
				if(!%currBrick.isPlanted)
					continue;
				%v1 = %currBrick.getDatablock().uiName @ "\"";
				%v2 = %currBrick.position;
				%v3 = %currBrick.angleID;
				%v4 = %currBrick.isBasePlate;
				%v5 = %currBrick.colorID;
				if(%currBrick.getDatablock().hasPrint)
					%v6 = getPrintName(%currBrick.printID);
				else
					%v6 = "";
				%v7 = %currbrick.colorFxID;
				%v8 = %currbrick.shapeFxID;
				%v9 = %currbrick.isRayCasting();
				%v10 = %currbrick.isColliding();
				%v11 = %currbrick.isRayCasting();
				%file.writeLine(%v1 SPC %v2 SPC %v3 SPC %v4 SPC %v5 SPC %v6 SPC %v7 SPC %v8 SPC %v9 SPC %v10 SPC %v11);
				if(%events)
				{
					if(%currbrick.getName())
						%file.writeLine("+-NTOBJECTNAME " @ %currbrick.getName());
					for(%y=0;%y<%currbrick.numEvents;%y++)
					{
						%e1 = %currbrick.eventEnabled[%y];
						%e2 = %currbrick.eventInput[%y];
						%e3 = %currbrick.eventDelay[%y];
						%e4 = %currbrick.eventTarget[%y];
						%et = %currbrick.eventNT[%y];
						%e5 = %currbrick.eventOutput[%y];
						for(%ev=1;%ev<=4;%ev++)
						{
							%e[%ev+5] = %currbrick.eventOutPutParameter[%y,%ev];
							if(%e[%ev+5] !$= "")
							{
								%iIDx = %currbrick.eventInputIdx[%y];
								%tIDx = %currbrick.eventTargetIdx[%y];
								%oIDx = %currbrick.eventOutputIdx[%y];
								if(%tIDx == -1)
									%targetClass = "fxDTSBrick";
								else
									%targetClass = getWord(getField($InputEvent_TargetList["fxDTSBrick",%iIDx],%tIDx),1);
								if(getWord(getField($OutputEvent_parameterList[%targetClass,%oIDx],%ev-1),0) $= "dataBlock")
								%e[%ev+5] = %e[%ev+5].getName();
							}
						}
						%file.writeLine("+-EVENT" TAB %y TAB %e1 TAB %e2 TAB %e3 TAB %e4 TAB %et TAB %e5 TAB %e6 TAB %e7 TAB %e8 TAB %e9);
					}
				}
				if(isObject(%currbrick.emitter))
					%file.writeLine("+-EMITTER" SPC %currbrick.emitter.emitter.uiName @ "\" " @ %currbrick.emitterDirection);
				if(isObject(%currbrick.light))
					%file.writeLine("+-LIGHT" SPC %currbrick.light.getDatablock().uiName @ "\" ");
				if(isObject(%currbrick.item))
					%file.writeLine("+-ITEM" SPC %currbrick.item.getDatablock().uiName @ "\" " @ %currbrick.itemPosition SPC %currbrick.itemDirection SPC %currbrick.itemRespawnTime);
				if(isObject(%currbrick.AudioEmitter))
					%file.writeLine("+-AUDIOEMITTER" SPC %currbrick.audioemitter.profile.uiName @ "\" ");
				if(isObject(%currbrick.vehicleDataBlock))
					%file.writeLine("+-VEHICLE" SPC %currbrick.vehicledatablock.uiName @ "\" " @ %currbrick.reColorVehicle);
				%saved[%currbrick] = 1;
			}
			//Don't check for stacktail, while duplicator does, it's because it doesn't want to duplicate
			//bricks attached to the bottom, where there may be bricks attached to the bottom of the baseplate
			//for example, if one is overhanging
			for(%i = 0; %i < %currBrick.getNumDownBricks(); %i++)
			{
				%newBrick = %currBrick.getDownBrick(%i);
				if(!%stackBrick[%newBrick])
				{
					%stackBrick[%newBrick] = 1;
					%stackList[%stackHead] = %newBrick;
					%stackHead++;
				}
			}
			for(%i = 0; %i < %currBrick.getNumUpBricks(); %i++)
			{
				%newBrick = %currBrick.getUpBrick(%i);
				if(!%stackBrick[%newBrick])
				{
					%stackBrick[%newBrick] = 1;
					%stackList[%stackHead] = %newBrick;
					%stackHead++;
				}
			}
		}
	}
	//Now loop through everything again to save all the floating bricks...
	for(%y=0;%y<mainBrickGroup.getCount();%y++)
	{
		%bg = mainBrickGroup.getObject(%y);
		for(%z=0;%z<%bg.getCount();%z++)
		{
			%currbrick = %bg.getObject(%z);
			if(!%saved[%currbrick]) //Found a floating brick, it will not have any ownership
			{
				if(!%currBrick.isPlanted)
					continue;
				%v1 = %currBrick.getDatablock().uiName @ "\"";
				%v2 = %currBrick.position;
				%v3 = %currBrick.angleID;
				%v4 = %currBrick.isBasePlate;
				%v5 = %currBrick.colorID;
				if(%currBrick.getDatablock().hasPrint)
					%v6 = getPrintName(%currBrick.printID);
				else
					%v6 = "";
				%v7 = %currbrick.colorFxID;
				%v8 = %currbrick.shapeFxID;
				%v9 = %currbrick.isRayCasting();
				%v10 = %currbrick.isColliding();
				%v11 = %currbrick.isRayCasting();
				%file.writeLine(%v1 SPC %v2 SPC %v3 SPC %v4 SPC %v5 SPC %v6 SPC %v7 SPC %v8 SPC %v9 SPC %v10 SPC %v11);
				if(%events)
				{
					if(%currbrick.getName())
						%file.writeLine("+-NTOBJECTNAME " @ %currbrick.getName());
					for(%y=0;%y<%currbrick.numEvents;%y++)
					{
						%e1 = %currbrick.eventEnabled[%y];
						%e2 = %currbrick.eventInput[%y];
						%e3 = %currbrick.eventDelay[%y];
						%e4 = %currbrick.eventTarget[%y];
						%et = %currbrick.eventNT[%y];
						%e5 = %currbrick.eventOutput[%y];
						for(%ev=1;%ev<=4;%ev++)
						{
							%e[%ev+5] = %currbrick.eventOutPutParameter[%y,%ev];
							if(%e[%ev+5] !$= "")
							{
								%iIDx = %currbrick.eventInputIdx[%y];
								%tIDx = %currbrick.eventTargetIdx[%y];
								%oIDx = %currbrick.eventOutputIdx[%y];
								if(%tIDx == -1)
									%targetClass = "fxDTSBrick";
								else
									%targetClass = getWord(getField($InputEvent_TargetList["fxDTSBrick",%iIDx],%tIDx),1);
								if(getWord(getField($OutputEvent_parameterList[%targetClass,%oIDx],%ev-1),0) $= "dataBlock")
								%e[%ev+5] = %e[%ev+5].getName();
							}	
						}
						%file.writeLine("+-EVENT" TAB %y TAB %e1 TAB %e2 TAB %e3 TAB %e4 TAB %et TAB %e5 TAB %e6 TAB %e7 TAB %e8 TAB %e9);
					}
				}
				if(isObject(%currbrick.emitter))
					%file.writeLine("+-EMITTER" SPC %currbrick.emitter.emitter.uiName @ "\" " @ %currbrick.emitterDirection);
				if(isObject(%currbrick.light))
					%file.writeLine("+-LIGHT" SPC %currbrick.light.getDatablock().uiName @ "\" ");
				if(isObject(%currbrick.item))
					%file.writeLine("+-ITEM" SPC %currbrick.item.getDatablock().uiName @ "\" " @ %currbrick.itemPosition SPC %currbrick.itemDirection SPC %currbrick.itemRespawnTime);
				if(isObject(%currbrick.AudioEmitter))
					%file.writeLine("+-AUDIOEMITTER" SPC %currbrick.audioemitter.profile.uiName @ "\" ");
				if(isObject(%currbrick.vehicleDataBlock))
					%file.writeLine("+-VEHICLE" SPC %currbrick.vehicledatablock.uiName @ "\" " @ %currbrick.reColorVehicle);
				%saved[%currbrick] = 1;
			}
		}
	}
	%file.close();
	%file.delete();
}

function ServerLoad(%name,%ownership,%map,%color,%silent)
{
	if(%map $= "")
		%map = MissionInfo.saveName;
	if(%color $= "")
		%color = 3;
	if(%ownership $= "")
		%ownership = 1;
	if(%silent $= "")
		%silent = 0;
	serverDirectSaveFileLoad("saves/" @ %map @ "/" @ %name @ ".bls", %color, "", %ownership, %silent);
}